#ifndef CGUL_H
#define CGUL_H

/**
 * Convenience header to include all other public headers.
 *
 * @file
 * @author Paul Serice
 * @brief convenience header to include all other public headers
 */

#include "cgul_common.h"

#include "cgul_base64.h"
#include "cgul_bcd.h"
#include "cgul_bdf.h"
#include "cgul_bdf_glyph.h"
#include "cgul_big_integer.h"
#include "cgul_binary_search.h"
#include "cgul_bitwise_trie.h"
#include "cgul_block_reader.h"
#include "cgul_block_reader_file.h"
#include "cgul_block_reader_memory.h"
#include "cgul_cache.h"
#include "cgul_char.h"
#include "cgul_convspec.h"
#include "cgul_crc16.h"
#include "cgul_crc16_incr.h"
#include "cgul_crc32.h"
#include "cgul_crc32_incr.h"
#include "cgul_crlf.h"
#include "cgul_crlf_file.h"
#include "cgul_csv.h"
#include "cgul_defensive.h"
#include "cgul_endian.h"
#include "cgul_event_router.h"
#include "cgul_exception.h"
#include "cgul_get_line.h"
#include "cgul_hash.h"
#include "cgul_hash_node.h"
#include "cgul_hchar.h"
#include "cgul_heap.h"
#include "cgul_heap_primitives.h"
#include "cgul_heap_sort.h"
#include "cgul_hex_dump.h"
#include "cgul_hstring.h"
#include "cgul_int.h"
#include "cgul_libc.h"
#include "cgul_line_wrapper.h"
#include "cgul_list.h"
#include "cgul_list_node.h"
#include "cgul_log2.h"
#include "cgul_merge_sort.h"
#include "cgul_microxml.h"
#include "cgul_mime.h"
#include "cgul_multimap.h"
#include "cgul_multimap_node.h"
#include "cgul_multiply64.h"
#include "cgul_progress_bar.h"
#include "cgul_radix_sort.h"
#include "cgul_random_bbs.h"
#include "cgul_random_cmwc32.h"
#include "cgul_random_lcg32.h"
#include "cgul_random_lcg256.h"
#include "cgul_random_lfg32.h"
#include "cgul_random_mt32.h"
#include "cgul_random_well32.h"
#include "cgul_random_xorshift32.h"
#include "cgul_random_xorwow32.h"
#include "cgul_rbtree.h"
#include "cgul_rbtree_node.h"
#include "cgul_rolling_hash.h"
#include "cgul_sbox.h"
#include "cgul_shuffle.h"
#include "cgul_split.h"
#include "cgul_stanza.h"
#include "cgul_stream_reader.h"
#include "cgul_string.h"
#include "cgul_strtok.h"
#include "cgul_substring.h"
#include "cgul_trie.h"
#include "cgul_trie_node.h"
#include "cgul_unicode.h"
#include "cgul_varsub.h"
#include "cgul_vector.h"
#include "cgul_wchar.h"
#include "cgul_wstring.h"


#endif  /*  CGUL_H  */
