#ifndef CGUL_RANDOM_XORWOW32_P_H
#define CGUL_RANDOM_XORWOW32_P_H

#include "cgul_common.h"
#include "cgul_random_xorwow32.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_random_xorwow32</code> class.
 */
struct cgul_random_xorwow32 {

    /*
     * NOTE: It is fast to expand the circular buffer so that each
     * element is an individual variable.  This saves time by not
     * having to constantly check if the indexes into the buffer have
     * wrapped around.
     */

    /**
     * The first element of the circular buffer.
     */
    cgul_uint32_t v0;

    /**
     * The second element of the circular buffer.
     */
    cgul_uint32_t v1;

    /**
     * The third element of the circular buffer.
     */
    cgul_uint32_t v2;

    /**
     * The fourth element of the circular buffer.
     */
    cgul_uint32_t v3;

    /**
     * The fifth element of the circular buffer.
     */
    cgul_uint32_t v4;

    /**
     * Current value for the Weyl Generator.
     */
    cgul_uint32_t weyl;

};

CGUL_END_C

#endif  /*  CGUL_RANDOM_XORWOW32_P_H  */
