#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    unsigned long int index = 0;
    cgul_string_cxx s;
    cgul_convspec_cxx cs;
    cgul_convspec_cxx cs2;

    try {

        /* Initialize cs. */
        index = 0;
        cs.deserialize("%-3.4d", &index);

        /* Perform a deep copy of cs. */
        cs2 = cs;

        /* Serialize cs2. */
        cs2.serialize(s);

        /* Print serialized version of cs2. */
        cout << "cs2 = \"" << s.get_value() << "\"" << endl;

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }
    
    return rv;
}
