#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    unsigned long value = 0;
    cgul_crc16_cxx* crc = NULL;

    try {

        /* Allocate. */
        crc = new cgul_crc16_cxx(0x1021, 0xffff, 0xffff, 0);

        /* Iterate over each file on the command line. */
        for (i = 1 ; i < argc ; ++i) {

            /* Calculate the CRC for this file. */
            value = crc->crc_fname(argv[i]);

            /* Print the CRC. */
            printf("%lu  %s\n", value, argv[i]);
        }

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    /* Clean up. */
    if (crc) {
        delete crc;
    }

    return rv;
}
