#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    unsigned long value = 0;
    cgul_crc32_t crc = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    crc = cgul_crc32__new_appends_size(&local, 0x04c11db7, 0, 0xffffffff, 0, 0);
    if (local) {
        goto out;
    }

    /* Iterate over each file on the command line. */
    for (i = 1 ; i < argc ; ++i) {

        /* Calculate the CRC for this file. */
        value = cgul_crc32__crc_fname(&local, crc, argv[i]);
        if (local) {
            goto out;
        }

        /* Print the CRC. */
        printf("%lu  %s\n", value, argv[i]);
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (crc) {
        cgul_crc32__delete(crc);
    }

    return rv;
}
