#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_list_node_cxx* curr = NULL;
    cgul_list_node_cxx* foo = NULL;
    cgul_list_node_cxx* bar = NULL;
    cgul_list_node_cxx* baz = NULL;

    try {

        /* Create the list. */
        cgul_list_cxx lst;

        /* Insert strings. */
        foo = lst.push_back("foo");
        bar = lst.push_back("bar");
        baz = lst.push_back("baz");

        /* Move nodes. */
        lst.move_before_node(NULL, foo);
        lst.move_after_node(NULL, foo);
        lst.move_after_node(foo, bar);

        /* Test to make sure trying to move a node before and after
         * itself do not change the list. */
        lst.move_before_node(baz, baz);
        lst.move_after_node(baz, baz);

        /* Print strings. */
        for (curr = lst.get_front() ; curr ; curr = curr->get_next()) {
            cout << (char*)curr->get_value() << endl;
        }

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
