#include <iostream>
#include "cgul_cxx.h"

using namespace std;

static void
print_list(cgul_list_cxx* lst)
{
    cgul_list_node_cxx* curr = NULL;

    for (curr = lst->get_front() ; curr ; curr = curr->get_next()) {
        cout << (char*)curr->get_value() << endl;
    }

    cout << "=====" << endl;
}

int
main(int argc,
     char* argv[])
{
    int rv = 0;

    try {

        /* Create the list. */
        cgul_list_cxx lst;

        /* Sort strings as they are inserted. */
        lst.insert_sorted("foo", (cgul_list__compare_t)strcmp);
        lst.insert_sorted("bar", (cgul_list__compare_t)strcmp);
        lst.insert_sorted("baz", (cgul_list__compare_t)strcmp);
        lst.insert_sorted("bar", (cgul_list__compare_t)strcmp);
        lst.insert_sorted("zzz", (cgul_list__compare_t)strcmp);

        /* Print list of strings. */
        print_list(&lst);

        /* Clear the list. */
        lst.clear(NULL);

        /* Add unsorted strings. */
        lst.push_back("foo");
        lst.push_back("bar");
        lst.push_back("baz");
        lst.push_back("bar");
        lst.push_back("zzz");

        /* Sort */
        lst.sort((cgul_list_cxx::compare_t)strcmp);

        /* Print list of strings. */
        print_list(&lst);

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
