#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    const char* fname = NULL;
    const char* boundary = NULL;
    cgul_exception_t local = NULL;

    /* Validate command line. */
    if (argc != 3) {
        fprintf(stderr, "Usage: main_mime_split_file <file> <boundary>\n");
        rv = 1;
        goto out;
    }

    /* Set parameters from the command line. */
    fname = argv[1];
    boundary = argv[2];

    /*
     * NOTE: If you appear to be having trouble with cgul_mime, make
     * sure you are passing in the correct boundary string with the
     * leading "--" prefix that shows up in the MIME message removed.
     */

    /* Split the mime file. */
    cgul_mime__split_fname(&local,
                           fname,
                           ".",
                           "mime-preamble",
                           "mime-header",
                           "mime-body",
                           "mime-epilogue",
                           boundary,
                           NULL);  /* auto eol */
    if (local) {
        goto out;
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
