#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* tmp = NULL;
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    s = cgul_string__new_from_cstring(&local, "Hello, World!");
    if (local) {
        goto out;
    }

    /* Take ownership of the underlying string. */
    tmp = cgul_string__take_value(&local, s);

    /* Print the string. */
    printf("tmp = %s\n", tmp);

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (tmp) {
        free(tmp);
    }
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
