#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    const char* s = NULL;
    cgul_strtok_cxx tok;

    try {

        /* Set the string to tokenize. */
        tok.set_value(",foo,bar,baz,");

        /* Iterate over each token. */
        while ((s = tok.get_next(",", 1)) != NULL) {
            cout << "    token: \"" << s << "\"" << endl;
            cout << "separator: \"" << tok.get_separator() << "\"" << endl;
            cout << "    start: " << tok.get_start() << endl;
            cout << "      end: " << tok.get_end() << endl;
            cout << endl;
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
