#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    size_t block_size = 104857600;
    char* block = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    block = cgul_libc__malloc(&local, block_size);
    if (local) {
        goto out;
    }

    /* Convert block to a C-style string so we can use strstr(). */
    memset(block, 1, block_size);
    block[block_size - 2] = '\2';
    block[block_size - 1] = '\0';

#if 1
    for (i = 0 ; i < block_size ; ++i) {
        if (block[i] > 2) {
            break;
        }
    }
    printf("i = %lu\n", (unsigned long)i);
#elif 0
    {
        char* ptr = strstr(block, "\x1\x1\x2");
        if (ptr) {
            printf("i = %lu\n", (unsigned long)(ptr - block));
        }
    }
#elif 0
    for (i = 0 ; i < block_size ; ++i) {
        if (memcmp(&block[i], "\x1\x1\x2", 3) == 0) {
            break;
        }
    }
    printf("i = %lu\n", (unsigned long)i);
#elif 1
    {
        const char* ptr = cgul_substring__search_ez(
                              &local, "\x1\x1\x2", 3, block, block_size);
        if (local) {
            goto out;
        }
        if (ptr) {
            printf("i = %lu\n", (unsigned long)(ptr - block));
        }
    }
#endif

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (block) {
        free(block);
    }

    return rv;
}
